| Home | Libraries | People | FAQ | More

##### segments_encoded_view::reference

(Inherited from `segments_encoded_base`)

The reference type.

###### Synopsis

    using reference = pct_string_view;

###### Types

Name | Description
--- | ---
const_iterator | The const iterator type.
const_pointer | The const pointer type.
const_reference | The const reference type.
const_reverse_iterator | The const reverse iterator type.
difference_type | The difference type.
iterator | The iterator type.
pointer | The pointer type.
reference | The reference type.
reverse_iterator | The reverse iterator type.
size_type | The size type.
traits_type | The character traits.
value_type | The value type.

###### Member Functions

Name | Description
--- | ---
at | Access a character.
back | Return the last character.
begin | Return an iterator to the beginning.
cbegin | Return an iterator to the beginning.
cend | Return an iterator to the end.
compare | Return the result of comparing to another string.
contains | Return true if matching characters are found.
copy | Copy the characters to another buffer.
crbegin | Return a reverse iterator to the end.
crend | Return a reverse iterator to the beginning.
data | Return a pointer to the character buffer.
decode | Return the string with percent-decoding.
decoded_size | Return the decoded size.
empty | Return true if the string is empty.
end | Return an iterator to the end.
ends_with | Return true if a matching suffix exists.
find | Return the position of matching characters.
find_first_not_of | Return the position of the first non-match.
find_first_of | Return the position of the first match.
find_last_not_of | Return the position of the last non-match.
find_last_of | Return the position of the last match.
front | Return the first character.
length | Return the size.
max_size | Return the maximum allowed size.
operator= | Assignment.
operator* | Return the string as a range of decoded characters.
operator[] | Access a character.
operator core::string_view | Conversion.
operator std::string | Conversion.
operator std::string_view | Conversion.
pct_string_view | Constructor. — Constructor (deleted)
rbegin | Return a reverse iterator to the end.
rend | Return a reverse iterator to the beginning.
rfind | Return the position of matching characters.
size | Return the size.
starts_with | Return true if a matching prefix exists.
substr | Return a view to part of the string.
swap | Swap.

###### Protected Member Functions

Name | Description
--- | ---
swap | Swap.

###### Static Members

Name | Description
--- | ---
npos | A constant used to represent "no position".

###### Protected Data Members

Name | Description
--- | ---
s_ | The referenced character buffer.

###### Friends

Name | Description
--- | ---
make_pct_string_view | Return a valid percent-encoded string.

Objects of this type behave like a `core::string_view` and have the same interface, but offer an additional invariant: they can only be constructed from strings containing valid percent-escapes. Attempting construction from a string containing invalid or malformed percent escapes results in an exception.

###### Operators

The following operators are supported between `pct_string_view` and any object that is convertible to `core::string_view`

    bool operator==( pct_string_view, pct_string_view ) noexcept ;
    bool operator!=( pct_string_view, pct_string_view ) noexcept ;
    bool operator<=( pct_string_view, pct_string_view ) noexcept ;
    bool operator< ( pct_string_view, pct_string_view ) noexcept ;
    bool operator> ( pct_string_view, pct_string_view ) noexcept ;
    bool operator>=( pct_string_view, pct_string_view ) noexcept ;

###### Description

This is the type of value returned when iterators of the view are dereferenced.